## fckit 0.9.0

=== CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# FCKIT

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.0.0 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

project( fckit LANGUAGES C CXX Fortran )

set(CMAKE_DIRECTORY_LABELS "fckit")
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################################
# options & dependencies

ecbuild_find_python( REQUIRED NO_LIBS )

### Fortran ...
ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )

ecbuild_check_fortran( FEATURES finalization )

set( FEATURE_FINAL_DEFAULT ON )
set( PGIBUG_ATLAS_197 0 )
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.4 )
      set( PGIBUG_ATLAS_197 1 )
  endif()
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.10 )
    # Compilation works, but runtime segmentation faults occur (tested with pgi/17.7)
    set( FEATURE_FINAL_DEFAULT OFF )
  else()
    list( APPEND FCKIT_QUARANTAINED_TESTS fckit_test_shared_ptr )
    # deallocation of list of shared_ptr only seems to deallocate first entry
  endif()
endif()

ecbuild_add_option( FEATURE FINAL
                    DESCRIPTION "Enable automatic finalisation for derived types (destructors)"
                    DEFAULT ${FEATURE_FINAL_DEFAULT}
                    CONDITION EC_HAVE_Fortran_FINALIZATION )

if( fckit_HAVE_FINAL )
    include( final-support )
    check_final_support()
    ecbuild_info( "FCKIT_HAVE_FINAL [1]")
    ecbuild_info( "  FCKIT_FINAL_FUNCTION_RESULT              = ${FCKIT_FINAL_FUNCTION_RESULT}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_LOCAL          = ${FCKIT_FINAL_UNINITIALIZED_LOCAL}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_INTENT_OUT     = ${FCKIT_FINAL_UNINITIALIZED_INTENT_OUT}")
    ecbuild_info( "  FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT   = ${FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT}")
    ecbuild_info( "  FCKIT_FINAL_NOT_PROPAGATING              = ${FCKIT_FINAL_NOT_PROPAGATING}")
    ecbuild_info( "  FCKIT_FINAL_NOT_INHERITING               = ${FCKIT_FINAL_NOT_INHERITING}")
    ecbuild_info( "  FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY = ${FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY}")
    ecbuild_info( "  FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY   = ${FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY}")
endif()
if( NOT fckit_HAVE_FINAL )
    ecbuild_info( "fckit_HAVE_FINAL [0]")
    set( FCKIT_FINAL_FUNCTION_RESULT              0 )
    set( FCKIT_FINAL_UNINITIALIZED_LOCAL          0 )
    set( FCKIT_FINAL_UNINITIALIZED_INTENT_OUT     0 )
    set( FCKIT_FINAL_UNINITIALIZED_INTENT_INOUT   0 )
    set( FCKIT_FINAL_NOT_PROPAGATING              0 )
    set( FCKIT_FINAL_NOT_INHERITING               0 )
    set( FCKIT_FINAL_BROKEN_FOR_ALLOCATABLE_ARRAY 0 )
    set( FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY   0 )
endif()

ecbuild_find_package( NAME eckit VERSION 1.5 QUIET )
ecbuild_add_option( FEATURE ECKIT
                    DESCRIPTION "Wrap ecKit functionality"
                    CONDITION eckit_FOUND )
if( NOT fckit_HAVE_ECKIT )
    ecbuild_warn("ecKit could not be found. This disables various fckit features such as MPI, Configuration, Logging")
endif()

## MPI
set( fckit_HAVE_ECKIT_MPI_PARALLEL 0 )
if( fckit_HAVE_ECKIT )
  if( eckit_HAVE_MPI OR ECKIT_HAVE_MPI )
    set( fckit_HAVE_ECKIT_MPI_PARALLEL 1 )
    set( HAVE_MPI 1 )
  else()
    set( fckit_HAVE_ECKIT_MPI_PARALLEL 0 )
    set( HAVE_MPI 0 )
  endif()
endif()
set( fckit_HAVE_MPI ${HAVE_MPI} )
if( fckit_HAVE_ECKIT AND NOT fckit_HAVE_MPI )
  ecbuild_warn("ecKit has been compiled without MPI. This causes fckit to not be able to run parallel executables.")
endif()

################################################################################################
# export package info

set( FCKIT_LIBRARIES  fckit )

################################################################################################
# sources

set( FYPP ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-eval.sh ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fckit-fypp.py )
set( FCTEST_GENERATOR ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/tools/fctest-generate-runner.py )
include( fckit_preprocess_fypp )
include( add_fctest )

add_subdirectory( src )
add_subdirectory( doc )

################################################################################################
# finalize

ecbuild_print_summary()
################################################################################################

if( ECBUILD_INSTALL_FORTRAN_MODULES )
    install( DIRECTORY ${CMAKE_Fortran_MODULE_DIRECTORY}/${CMAKE_CFG_INTDIR}
             DESTINATION module/fckit
             COMPONENT modules )
endif()
if( NOT PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )
  set( FCTEST_GENERATOR ${FCTEST_GENERATOR} PARENT_SCOPE )
  set( FYPP ${FYPP} PARENT_SCOPE )
endif()
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/add_fctest.cmake ADD_FCTEST)
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/cmake/fckit_preprocess_fypp.cmake FCKIT_PREPROCESS_FYPP )

set( install_permissions OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
install( FILES tools/fctest-generate-runner.py DESTINATION libexec PERMISSIONS ${install_permissions} )
install( FILES tools/fckit-eval.sh DESTINATION libexec PERMISSIONS ${install_permissions} )
install( FILES contrib/fypp-679566c-20190108/bin/fypp DESTINATION libexec RENAME fckit-fypp.py PERMISSIONS ${install_permissions} )

ecbuild_install_project( NAME fckit )

=== src/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

add_subdirectory(fckit)
add_subdirectory(apps)
add_subdirectory(tests)

if ( HAVE_SANDBOX )
  add_subdirectory(sandbox)
endif()

=== doc/fctest_examples/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.6 FATAL_ERROR )

find_package( ecbuild 3.0.0 REQUIRED )

project( fctest_examples VERSION 0.0.0 LANGUAGES Fortran )

ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )

find_package( fckit REQUIRED )

ecbuild_add_library( TARGET fctest_example_lib
                     SOURCES fctest_example_lib.F90
                     NOINSTALL )

add_fctest( TARGET fctest_example_simple
            LINKER_LANGUAGE Fortran
            SOURCES fctest_example_simple.F90
            LIBS    fctest_example_lib )

add_fctest( TARGET fctest_example_with_fixture
            LINKER_LANGUAGE Fortran
            SOURCES fctest_example_with_fixture.F90 )

=== src/fckit/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

configure_file(fckit.h.in  fckit.h)
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/fckit.h DESTINATION include/fckit )
set( source_files_properties fckit.h.in PROPERTIES HEADER_FILE_ONLY TRUE )

if( HAVE_ECKIT )
  list( APPEND eckit_required_src
      module/fckit.F90
      module/fckit_pathname.F90
      module/fckit_configuration.F90
      module/fckit_configuration.cc
      module/fckit_mpi.cc
      module/fckit_mpi.fypp
      module/fckit_main.cc
      module/fckit_main.F90
      module/fckit_exception.F90
      module/fckit_signal.F90
      module/fckit_resource.cc
      module/fckit_resource.F90
      module/fckit_log.cc
      module/fckit_log.F90
      module/fckit_buffer.cc
      module/fckit_buffer.F90
      module/fckit_owned.cc
      module/fckit_owned_object.F90
      Libfckit.h
      Libfckit.cc
      Main.h
      Main.cc
      Log.h
      Log.cc
  )
  set( eckit_required_libs eckit eckit_mpi )
endif()

if( BUILD_SHARED_LIBS )
    set( fckit_type SHARED )
else()
    set( fckit_type STATIC )
endif()

if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
  # Bug tested with pgi/17.7 (fixed pgi/19.4) requires fckit to be compiled statically
  if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.4 )
      ecbuild_warn( "Bug in pgi < 19.4 requires fckit to be compiled statically" )
      set( fckit_type STATIC )
  endif()

  # Turn off all compiler warnings for reason :
  #   PGF90-W-0435-Array declared with zero size
  #      (/tmp/nawd/atlas-bundle/source/fckit/src/fckit/module/fckit_array.F90: 25)
  set_source_files_properties( module/fckit_array.F90  PROPERTIES COMPILE_FLAGS "-w" )
endif()


ecbuild_add_library( 
    TARGET     fckit
    LINKER_LANGUAGE CXX
        # We need the C++ linker for the error handling to work
        # Otherwise death by recursion in function "fckit_terminate"
        # when uncaught exceptions are encountered
    SOURCES
               fctest.h
               fctest.F90
               Log.F90
               module/fckit_array.F90
               module/fckit_C_interop.cc
               module/fckit_C_interop.F90
               module/fckit_object.F90
               module/fckit_final.F90
               module/fckit_refcount.F90
               module/fckit_shared_ptr.F90
               module/fckit_shared_object.F90
               ${eckit_required_src}
    PRIVATE_INCLUDES
               ${ECKIT_INCLUDE_DIRS}
               ${CMAKE_CURRENT_BINARY_DIR}

    INSTALL_HEADERS_LIST
               fctest.h
               Log.h
               Main.h

    HEADER_DESTINATION  include/fckit

    PUBLIC_INCLUDES
        $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
        $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
        $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
        $<INSTALL_INTERFACE:include>
        $<INSTALL_INTERFACE:module/fckit>

    PRIVATE_LIBS
       ${eckit_required_libs}

    TYPE ${fckit_type}

)

fckit_target_preprocess_fypp( fckit )

=== src/tests/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

cmake_policy( SET CMP0064 NEW ) # Recognize ``TEST`` as operator for the ``if()`` command. (introduced in CMake version 3.4)

add_fctest( TARGET  fckit_test_array
            LINKER_LANGUAGE Fortran
            SOURCES test_array.F90
            LIBS    fckit)

add_fctest( TARGET  fckit_test_resource
            LINKER_LANGUAGE Fortran
            SOURCES test_resource.F90
            ARGS    -integer 10 -long 5000000000 -float 0.123456 -double 0.1234567890123456789 -string "hello world"
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_log
            LINKER_LANGUAGE Fortran
            SOURCES test_log.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_shared_ptr
            LINKER_LANGUAGE Fortran
            SOURCES
              test_shared_ptr.F90
              test_shared_ptr.cc
            LIBS    fckit)

add_fctest( TARGET  fckit_test_mpi
            LINKER_LANGUAGE Fortran
            SOURCES test_mpi.F90
            MPI 4
            CONDITION HAVE_MPI
            LIBS    fckit)

add_fctest( TARGET  fckit_test_abort
            LINKER_LANGUAGE Fortran
            SOURCES test_abort.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)

add_fctest( TARGET  fckit_test_configuration
            LINKER_LANGUAGE Fortran
            SOURCES test_configuration.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)
if( TEST fckit_test_configuration )
  if( NOT CMAKE_VERSION VERSION_LESS 3.15 ) # support for COMPILE_LANG_AND_ID generator expression
    target_compile_options( fckit_test_configuration PRIVATE $<$<COMPILE_LANG_AND_ID:Fortran,GNU>:-Wno-uninitialized> )
  endif()
endif()

add_fctest( TARGET  fckit_test_configuration_fails
            LINKER_LANGUAGE Fortran
            SOURCES test_configuration_fails.F90
            CONDITION HAVE_ECKIT
            LIBS    fckit)
if( TEST fckit_test_configuration_fails )
    set_tests_properties( fckit_test_configuration_fails PROPERTIES
    PASS_REGULAR_EXPRESSION "Could not find \"missing\" in Configuration")
endif()

add_fctest( TARGET  fckit_test_broadcast_file
            LINKER_LANGUAGE Fortran
            SOURCES test_broadcast_file.F90
            MPI 4
            CONDITION HAVE_MPI
            LIBS    fckit)

add_fctest( TARGET fckit_test_fypp
  LINKER_LANGUAGE Fortran
  SOURCES test_fypp.fypp
  LIBS fckit
)

ecbuild_add_test( TARGET  fckit_test_configuration_cpp
            LINKER_LANGUAGE Fortran
            SOURCES
            test_configuration.cc
            test_configuration_fortcode.F90
            INCLUDES ${ECKIT_INCLUDE_DIRS}
            CONDITION HAVE_ECKIT
            LIBS    fckit  eckit eckit_mpi )

if( TEST fckit_test_configuration_cpp )
  set_property( TEST fckit_test_configuration_cpp APPEND PROPERTY LABELS "fortran" )
endif()

ecbuild_add_test( TARGET fckit_test_cpp
  LINKER_LANGUAGE Fortran
  SOURCES test_cpp.cc test_cpp_fortcode.F90
  INCLUDES ${ECKIT_INCLUDE_DIRS}
  ENVIRONMENT "DEBUG=1"
  CONDITION HAVE_ECKIT
  LIBS fckit eckit eckit_mpi )

### Fix linking for C++ test executables linked with Fortran linker
if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
  set( NO_MAIN "-Mnomain" )
elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
  set( NO_MAIN "-nofor-main" )
endif()
if( NO_MAIN )
  foreach( _test fckit_test_configuration_cpp fckit_test_cpp )
    if( TEST ${_test} )
      set_target_properties(${_test} PROPERTIES LINK_FLAGS ${NO_MAIN} )
    endif()
  endforeach()
endif()

### Quarantaine tests if requested
foreach( _test ${FCKIT_QUARANTAINED_TESTS} )
    if( TEST ${_test} )
      set_tests_properties( ${_test} PROPERTIES WILL_FAIL 1 )
      ecbuild_warn("Test ${_test} is quarantained (shows as passed)")
    endif()
endforeach()

### Test downstream find_package(fckit) projects
add_subdirectory( test_downstream_fypp )
add_subdirectory( test_downstream_fctest )

=== src/tests/test_downstream_fctest/CMakeLists.txt ===

# This test builds a package that requires fypp processing
# It uses the overriding of compile flags, like IFS is using.
#
# Test created to avoid regression after fixing issue FCKIT-19,
# where compile flags were not propagated to fypp-generated files.

if( HAVE_TESTS )
    
  configure_file( test-downstream.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh @ONLY )

  unset( _test_args )
  if( CMAKE_TOOLCHAIN_FILE )
    list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
  endif()
  foreach( lang C CXX Fortran )
    if( CMAKE_${lang}_COMPILER )
      list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
    endif()
  endforeach()

  add_test( NAME fckit_test_downstream_fctest
            COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh ${_test_args} )

endif()

=== src/tests/test_downstream_fypp/CMakeLists.txt ===

# This test builds a package that requires fypp processing
# It uses the overriding of compile flags, like IFS is using.
#
# Test created to avoid regression after fixing issue FCKIT-19,
# where compile flags were not propagated to fypp-generated files.

if( HAVE_TESTS AND HAVE_ECKIT )

  configure_file( test-downstream.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh @ONLY )

  unset( _test_args )
  if( CMAKE_TOOLCHAIN_FILE )
    list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
  endif()
  foreach( lang C CXX Fortran )
    if( CMAKE_${lang}_COMPILER )
      list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
    endif()
  endforeach()

  add_test( NAME fckit_test_downstream_fypp
            COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test-downstream.sh ${_test_args} )

endif()

=== src/tests/test_downstream_fypp/downstream/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 FATAL_ERROR )

find_package( ecbuild REQUIRED )

project( downstream VERSION 0.1.0 LANGUAGES Fortran)

find_package( fckit REQUIRED COMPONENTS ECKIT )

ecbuild_add_library( TARGET downstream SOURCES downstream.fypp downstream_override.fypp LIBS fckit )
fckit_target_preprocess_fypp( downstream )

ecbuild_add_executable( TARGET main SOURCES main.F90 LIBS fckit downstream )

=== debian/changelog ===
fckit (0.9.0-6) unstable; urgency=medium

  * Rebuild against eckit >= 1.15.4-1

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Jan 2021 22:28:51 +0000

fckit (0.9.0-5) unstable; urgency=medium

  * libfckit-dev requires a Fortran compiler
  * Change python3.x -> python3 in cmake files
  * Drop kernel name  for reproducible builds. Closes: #977641
  * Standards-Version: 4.5.1. No changes required
  * Point homepage to github
  * Add debian/watch file

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Jan 2021 11:05:53 +0000

fckit (0.9.0-4) unstable; urgency=medium

  * Patch 32-bit systems to drop broken support for mpi int64 type.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Oct 2020 12:59:20 +0100

fckit (0.9.0-3) unstable; urgency=medium

  * Add d/not-installed for files not installed in binary-all builds.
    Closes: #972451

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 19 Oct 2020 07:51:38 +0100

fckit (0.9.0-2) unstable; urgency=medium

  * Make build reproducible. Closes: #972378
  * Fix cmake scripts to build atlas-ecmwf:
    - change refernences libfckit.so.0d -> libfckit-gfortran.so.0d

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 18 Oct 2020 09:42:30 +0100

fckit (0.9.0-1) unstable; urgency=medium

  * New upstream release
  * Debhelper level 13
  * Add d/gbp.conf to point to DEP-14 branches
  * Change Vcs-Git to point to debian/latest branch
  * Change fckit-util -> libfckit-utils (error in d/control)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 16 Oct 2020 12:23:06 +0100

fckit (0.6.6-1) unstable; urgency=medium

  * Initial release. (Closes: #934365)
  * Compared to first upload:
    - Change libfckit-utils to fckit-utils
    - Acknowledge BSD license of contrib/fypp-* code
    - Change cmake contents to enable atlas, metview to compile
    - Build-Depend on libeckit-dev, not libodb-api-dev, following refactor.
    - patchelf on libraries until SKIP_RPATH is fixed
    - Drop dependency on flang until next flang release
    - Add lintian-overrides files

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 25 May 2020 10:30:29 +0100

=== debian/control ===
Source: fckit
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-sequence-fortran-mod,
  gfortran | fortran-compiler,
  patchelf,
  ecbuild (>= 3.3.0-2),
  python3-all,
  libeckit-dev (>= 1.15.4-1),
  libssl-dev,
  libcurl4-gnutls-dev
Standards-Version: 4.5.1
Homepage: https://github.com/ecmwf/fckit
Vcs-Browser: https://salsa.debian.org:/mckinstry/fckit.git
Vcs-Git: https://salsa.debian.org:/mckinstry/fckit.git -b debian/latest

Package: libfckit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libfckit0d (= ${binary:Version}), ${shlib:Depends}, ${misc:Depends},
 gfortran | fortran-compiler
Description: Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit0d
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libfckit-utils
Architecture: all
Depends: ${misc:Depends}, libfckit-dev, python3
Description: Library Fortran toolkit for interoperating Fortran with C/C++
 This is a toolkit from ECMWF to make ecKit interoperable with Fortran.
 .
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f


# TODO:
#   - Flang version doesn't build. 

export DH_VERBOSE=1

AUTOGENERATED:= libfckit-dev.install

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
GFORTRAN_VERSION:=$(shell basename $(shell readlink  /usr/bin/gfortran))
FLANG_VERSION:=$(shell basename $(shell readlink  /usr/bin/flang))

TMPDIR:=$(CURDIR)/debian/tmp
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
MODULEDIR:=$(LIBDIR)/fortran/$(GFORTRAN_VERSION)
# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

PATCH_ON_32BIT_ARCH:= powerpc armel armhf i386 mipsel 
DO_PATCH:=     $(if $(filter $(DEB_TARGET_ARCH), $(PATCH_ON_32BIT_ARCH)), true, false)

BUILD_FLAGS = 

%:
	dh $@ --buildsystem=ecbuild

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -rf debian/build-*

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
		sed -e 's%@GFORTRAN_VERSION@%${GFORTRAN_VERSION}%g'   < debian/$$f.in  |  	\
		sed -e 's%@FLANG_VERSION@%${FLANG_VERSION}%g'   > debian/$$f ; \
                done
	$(DO_PATCH) && (patch -p1 < debian/patches/32-bit-mpi.patch ) || true
	dh_auto_configure --builddirectory=debian/build-gfortran -- \
			${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=/usr/bin/gfortran
	#dh_auto_configure --builddirectory=debian/build-flang -- \
#				${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=/usr/bin/flang

override_dh_auto_test:
	dh_auto_test --builddirectory=debian/build-gfortran
	@echo Skip flang tests for now

override_dh_auto_build:
	dh_auto_build --builddirectory=debian/build-gfortran
        # Fails to build with 201903 flang
	#dh_auto_build --builddirectory=debian/build-flang

override_dh_auto_install:
	dh_auto_install --builddirectory=debian/build-gfortran
	# dh_auto_build --builddirectory=debian/build-flang
	# Fixup cmake files. Hack. can we do better with patches to upstream ?
	sed -i -e 's%$${FCKIT_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g'               	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-fypp.py%fckit-fypp%' 		         	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fckit-eval.sh%fckit-eval%'                          	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%fctest-generate-runner.py%fctest-generate-runner%'  	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	sed -i -e 's%/usr/lib/cmake%${LIBDIR}/cmake%g'  		 	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/lib/libfckit%${LIBDIR}/libfckit%g'            $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/include%/usr/include/${DEB_HOST_MULTIARCH}%g' $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%$${_IMPORT_PREFIX}/module%${MODULEDIR}%g' 			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets.cmake
	sed -i -e 's%python3\.[0-9]*%python3%g'  				      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
	# TODO: This will need work when flang is supported
	sed -i -e 's%libfckit.so.0d%libfckit-gfortran.so.0d%g'			      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-targets-release.cmake
	# rename those with script extensions
	mv $(TMPDIR)/usr/libexec/fckit-eval.sh $(TMPDIR)/usr/libexec/fckit-eval
	mv $(TMPDIR)/usr/libexec/fckit-fypp.py $(TMPDIR)/usr/libexec/fckit-fypp
	mv $(TMPDIR)/usr/libexec/fctest-generate-runner.py $(TMPDIR)/usr/libexec/fctest-generate-runner
	chmod -x $(TMPDIR)/$(LIBDIR)/cmake/fckit/*
	mv $(TMPDIR)/$(LIBDIR)/libfckit.so.0d $(TMPDIR)/$(LIBDIR)/libfckit-gfortran.so.0d
	rm $(TMPDIR)/$(LIBDIR)/libfckit.so 
	patchelf  --set-soname libfckit-gfortran.so.0d $(TMPDIR)/$(LIBDIR)/libfckit-gfortran.so.0d
	patchelf  --remove-rpath $(TMPDIR)/$(LIBDIR)/libfckit-gfortran.so.0d
	dh_link -p libfckit-dev $(LIBDIR)/libfckit-gfortran.so.0d $(LIBDIR)/fortran/$(GFORTRAN_VERSION)/libfckit.so
	dh_link -p libfckit-dev $(LIBDIR)/libfckit-gfortran.so.0d $(LIBDIR)/libfckit-gfortran.so

override_dh_dwz:
	@echo "Override dwz as it breaks on shlibs edited by patchelf"

## fckit 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 
 cmake_minimum_required( VERSION 3.12 FATAL_ERROR )
 
-find_package( ecbuild 3.0.0 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )
+find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )
 
 project( fckit LANGUAGES C CXX Fortran )
 
@@ -74,7 +74,7 @@
     set( FCKIT_FINAL_BROKEN_FOR_AUTOMATIC_ARRAY   0 )
 endif()
 
-ecbuild_find_package( NAME eckit VERSION 1.5 QUIET )
+ecbuild_find_package( NAME eckit VERSION 1.14 QUIET )
 ecbuild_add_option( FEATURE ECKIT
                     DESCRIPTION "Wrap ecKit functionality"
                     CONDITION eckit_FOUND )
@@ -135,6 +135,6 @@
 set( install_permissions OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE )
 install( FILES tools/fctest-generate-runner.py DESTINATION libexec PERMISSIONS ${install_permissions} )
 install( FILES tools/fckit-eval.sh DESTINATION libexec PERMISSIONS ${install_permissions} )
-install( FILES contrib/fypp-679566c-20190108/bin/fypp DESTINATION libexec RENAME fckit-fypp.py PERMISSIONS ${install_permissions} )
+install( FILES contrib/fypp-3.0-7895a7e-20200112/bin/fypp DESTINATION libexec RENAME fckit-fypp.py PERMISSIONS ${install_permissions} )
 
 ecbuild_install_project( NAME fckit )

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -64,7 +64,8 @@
             LIBS    fckit)
 if( TEST fckit_test_configuration_fails )
     set_tests_properties( fckit_test_configuration_fails PROPERTIES
-    PASS_REGULAR_EXPRESSION "Could not find \"missing\" in Configuration")
+        PASS_REGULAR_EXPRESSION "Could not find \"missing\" in Configuration"
+        TIMEOUT 5 )
 endif()
 
 add_fctest( TARGET  fckit_test_broadcast_file

=== debian/changelog ===
fckit (0.9.3-1build1) impish; urgency=medium

  * Rebuild against new glibc 2.34.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Aug 2021 14:24:32 +0200

fckit (0.9.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 16 Jun 2021 15:18:45 +0100

fckit (0.9.2-2) unstable; urgency=medium

  * FCKIT_INSTALL_PREFIX now fckit_INSTALL_PREFIX in cmake; change d/rules

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 27 Mar 2021 19:40:50 +0000

fckit (0.9.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 23 Mar 2021 08:36:09 +0000

fckit (0.9.1-6) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 10 Mar 2021 12:20:36 +0000

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
   patchelf,
   ecbuild (>= 3.3.0-2),
   python3-all,
-  libeckit-dev (>= 1.15.4-1),
+  libeckit-dev (>= 1.15.4-1~),
   libssl-dev,
   libcurl4-gnutls-dev
 Standards-Version: 4.5.1

## fckit 0.9.5

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -103,10 +103,12 @@
   LIBS fckit eckit eckit_mpi )
 
 ### Fix linking for C++ test executables linked with Fortran linker
-if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
+if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
   set( NO_MAIN "-Mnomain" )
 elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Intel" )
   set( NO_MAIN "-nofor-main" )
+elseif( CMAKE_Fortran_COMPILER_ID MATCHES "Fujitsu" )
+  set( NO_MAIN "-mlcmain=main" )
 endif()
 if( NO_MAIN )
   foreach( _test fckit_test_configuration_cpp fckit_test_cpp )

=== src/tests/test_downstream_fypp/downstream/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 find_package( fckit REQUIRED COMPONENTS ECKIT )
 
-ecbuild_add_library( TARGET downstream SOURCES downstream.fypp downstream_override.fypp LIBS fckit )
+ecbuild_add_library( TARGET downstream SOURCES downstream.fypp downstream_override.fypp PUBLIC_LIBS fckit )
 fckit_target_preprocess_fypp( downstream )
 
 ecbuild_add_executable( TARGET main SOURCES main.F90 LIBS fckit downstream )

=== debian/changelog ===
fckit (0.9.5-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 08 Dec 2021 20:13:05 +0000

fckit (0.9.4-2) unstable; urgency=medium

  * Only build on 64-bit archs as we depend on 64-bit eckit

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 11 Oct 2021 09:06:56 +0100

fckit (0.9.4-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 25 Aug 2021 09:43:40 +0100

=== debian/control ===
--- 
+++ 
@@ -11,14 +11,14 @@
   libeckit-dev (>= 1.15.4-1~),
   libssl-dev,
   libcurl4-gnutls-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/ecmwf/fckit
 Vcs-Browser: https://salsa.debian.org:/mckinstry/fckit.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/fckit.git -b debian/latest
 
 Package: libfckit-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Multi-Arch: same
 Depends: libfckit0d (= ${binary:Version}), ${shlib:Depends}, ${misc:Depends},
  gfortran | fortran-compiler
@@ -29,7 +29,7 @@
 
 Package: libfckit0d
 Section: libs
-Architecture: any
+Architecture: amd64 arm64 ppc64 mips64el ppc64el s390x riscv64 sparc64  kfreebsd-amd64 ia64 alpha
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Library Fortran toolkit for interoperating Fortran with C/C++

=== debian/rules ===
--- 
+++ 
@@ -55,7 +55,7 @@
 	dh_auto_install --builddirectory=debian/build-gfortran
 	# dh_auto_build --builddirectory=debian/build-flang
 	# Fixup cmake files. Hack. can we do better with patches to upstream ?
-	sed -i -e 's%$${FCKIT_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
+	sed -i -e 's%$${fckit_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%/usr/bin/python %/usr/bin/python3 %g'               	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%fckit-fypp.py%fckit-fypp%' 		         	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake

## fckit 0.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 ################################################################################################
 # options & dependencies
 
-ecbuild_find_python( REQUIRED NO_LIBS )
+ecbuild_find_python( VERSION 3.4 REQUIRED NO_LIBS )
 
 ### Fortran ...
 ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )
@@ -31,7 +31,7 @@
 
 set( FEATURE_FINAL_DEFAULT ON )
 set( PGIBUG_ATLAS_197 0 )
-if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
+if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
   if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.4 )
       set( PGIBUG_ATLAS_197 1 )
   endif()

=== src/apps/CMakeLists.txt ===
get_property( langs GLOBAL PROPERTY ENABLED_LANGUAGES )

foreach( lang ${langs} )
  set( EC_${lang}_FLAGS "${CMAKE_${lang}_FLAGS} ${CMAKE_${lang}_FLAGS_${CMAKE_BUILD_TYPE_CAPS}}" )
endforeach()

configure_file( fckit.in ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/fckit )

file(COPY ${CMAKE_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/fckit
  DESTINATION ${CMAKE_BINARY_DIR}/bin
  FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ
  GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install( FILES
  ${CMAKE_BINARY_DIR}/bin/fckit
  DESTINATION
  ${INSTALL_BIN_DIR}
  PERMISSIONS
  OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
)

=== src/fckit/CMakeLists.txt ===
--- 
+++ 
@@ -46,7 +46,7 @@
     set( fckit_type STATIC )
 endif()
 
-if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI" )
+if( CMAKE_Fortran_COMPILER_ID MATCHES "PGI|NVHPC" )
   # Bug tested with pgi/17.7 (fixed pgi/19.4) requires fckit to be compiled statically
   if( ${CMAKE_Fortran_COMPILER_VERSION} VERSION_LESS 19.4 )
       ecbuild_warn( "Bug in pgi < 19.4 requires fckit to be compiled statically" )

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -65,7 +65,7 @@
 if( TEST fckit_test_configuration_fails )
     set_tests_properties( fckit_test_configuration_fails PROPERTIES
         PASS_REGULAR_EXPRESSION "Could not find \"missing\" in Configuration"
-        TIMEOUT 5 )
+        TIMEOUT 20 )
 endif()
 
 add_fctest( TARGET  fckit_test_broadcast_file

=== debian/changelog ===
fckit (0.10.0-2) unstable; urgency=medium

  * mips64el may fail on MPI test on build systems; ignore

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Dec 2022 09:53:38 +0000

fckit (0.10.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 04 Dec 2022 11:19:07 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
   libeckit-dev (>= 1.15.4-1~),
   libssl-dev,
   libcurl4-gnutls-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/ecmwf/fckit
 Vcs-Browser: https://salsa.debian.org:/mckinstry/fckit.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/fckit.git -b debian/latest

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+include /usr/share/dpkg/pkg-info.mk
 
 # TODO:
 #   - Flang version doesn't build. 
@@ -23,6 +24,9 @@
 
 BUILD_FLAGS = 
 
+NO_TEST_ARCH:= mips64el 
+DO_TEST:= $(if $(filter $(DEB_TARGET_ARCH), $(NO_TEST_ARCH)), false, true)
+
 %:
 	dh $@ --buildsystem=ecbuild
 
@@ -43,7 +47,7 @@
 #				${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=/usr/bin/flang
 
 override_dh_auto_test:
-	dh_auto_test --builddirectory=debian/build-gfortran
+	$(DO_TEST) && (dh_auto_test --builddirectory=debian/build-gfortran ) || echo "Ignoring test failures"
 	@echo Skip flang tests for now
 
 override_dh_auto_build:

## fckit 0.10.1

=== debian/changelog ===
fckit (0.10.1-3) unstable; urgency=medium

  * Rebuild against latest dh-fortran-mod for gfortran-13

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 20 Jun 2023 11:59:24 +0100

fckit (0.10.1-2) unstable; urgency=medium

  * Push to unstable
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 11 Jun 2023 12:00:47 +0100

fckit (0.10.1-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 11 Mar 2023 09:31:18 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
   libeckit-dev (>= 1.15.4-1~),
   libssl-dev,
   libcurl4-gnutls-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/ecmwf/fckit
 Vcs-Browser: https://salsa.debian.org:/mckinstry/fckit.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/fckit.git -b debian/latest

## fckit 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 project( fckit LANGUAGES C CXX Fortran )
 
 set(CMAKE_DIRECTORY_LABELS "fckit")
-set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 ################################################################################################

=== src/fckit/CMakeLists.txt ===
--- 
+++ 
@@ -30,6 +30,10 @@
       module/fckit_buffer.F90
       module/fckit_owned.cc
       module/fckit_owned_object.F90
+      module/fckit_map.cc
+      module/fckit_map.F90
+      module/fckit_tensor.cc
+      module/fckit_tensor.F90
       Libfckit.h
       Libfckit.cc
       Main.h

=== src/tests/CMakeLists.txt ===
--- 
+++ 
@@ -45,6 +45,22 @@
             SOURCES test_abort.F90
             CONDITION HAVE_ECKIT
             LIBS    fckit)
+
+add_fctest( TARGET  fckit_test_map
+            LINKER_LANGUAGE Fortran
+            SOURCES test_map.F90
+            CONDITION HAVE_ECKIT
+            LIBS    fckit)            
+
+add_fctest( TARGET  fckit_test_tensor
+            LINKER_LANGUAGE Fortran
+            SOURCES 
+              test_tensor.F90
+              test_tensor.cc
+            INCLUDES ${ECKIT_INCLUDE_DIRS}
+            CONDITION HAVE_ECKIT
+            LIBS  eckit fckit)            
+
 
 add_fctest( TARGET  fckit_test_configuration
             LINKER_LANGUAGE Fortran

=== src/tests/test_downstream_fypp/downstream/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6 FATAL_ERROR )

find_package( ecbuild REQUIRED )

project( downstream VERSION 0.1.0 LANGUAGES Fortran)

find_package( fckit REQUIRED COMPONENTS ECKIT )


ecbuild_add_library(
    TARGET downstream
    SOURCES downstream.fypp downstream_override.fypp
    PUBLIC_LIBS fckit
    DEFINITIONS _POSIX_C_SOURCE=200809L exclude_from_fypp)
fckit_target_preprocess_fypp( downstream FYPP_ARGS_EXCLUDE "exclude_from_fypp" )

ecbuild_add_executable( TARGET main SOURCES main.F90 LIBS fckit downstream )

=== debian/changelog ===
fckit (0.11.0-1) unstable; urgency=medium

  * New upstream release`

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 08 Aug 2023 13:47:05 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Build-Depends: debhelper-compat (= 13), 
   dh-sequence-fortran-mod,
   gfortran | fortran-compiler,
+  flang-15 [amd64 arm64 ppc64 ppc64el riscv64],
   patchelf,
   ecbuild (>= 3.3.0-2),
   python3-all,

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,9 @@
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 GFORTRAN_VERSION:=$(shell basename $(shell readlink  /usr/bin/gfortran))
-FLANG_VERSION:=$(shell basename $(shell readlink  /usr/bin/flang))
+# FLANG_VERSION:=$(shell basename $(shell readlink  /usr/bin/flang* | head -1))
+FLANG_VERSION=flang-15
+FLANG_VERSION_NAME=flang-new-15
 
 TMPDIR:=$(CURDIR)/debian/tmp
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
@@ -44,7 +46,7 @@
 	dh_auto_configure --builddirectory=debian/build-gfortran -- \
 			${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=/usr/bin/gfortran
 	#dh_auto_configure --builddirectory=debian/build-flang -- \
-#				${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=/usr/bin/flang
+	#			${BUILD_FLAGS} -DCMAKE_Fortran_COMPILER=/usr/bin/${FLANG_VERSION_NAME}
 
 override_dh_auto_test:
 	$(DO_TEST) && (dh_auto_test --builddirectory=debian/build-gfortran ) || echo "Ignoring test failures"
@@ -52,12 +54,11 @@
 
 override_dh_auto_build:
 	dh_auto_build --builddirectory=debian/build-gfortran
-        # Fails to build with 201903 flang
 	#dh_auto_build --builddirectory=debian/build-flang
 
 override_dh_auto_install:
 	dh_auto_install --builddirectory=debian/build-gfortran
-	# dh_auto_build --builddirectory=debian/build-flang
+	#  dh_auto_build --builddirectory=debian/build-flang
 	# Fixup cmake files. Hack. can we do better with patches to upstream ?
 	sed -i -e 's%$${fckit_INSTALL_PREFIX}/libexec%/usr/bin%g'        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
 	sed -i -e 's%${CURDIR}%/build/fckit/%g'     	        	      $(TMPDIR)/$(LIBDIR)/cmake/fckit/fckit-import.cmake
